#include <sourcemod>
#include <vip_core>

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo = 
{
	name	= "[VIP] Gloves",
	author	= "xstage",
	version	= "1.0.0"
};

#define ERROR(%0) SetFailState(%0);return

static const char sCmd[][] = {
	"sm_gloves",
	"sm_glove",
	"sm_eldiven",
	"sm_gllang"
};

Handle
	g_hDatabase;
KeyValues
	g_hKeyValues;
char
	g_sWarning[128],
	g_sVIPGroup[64],
	g_sVIPMessage[128],
	g_sDBPrefix[10];

public void OnPluginStart()
{
	Load_KeyValues("data/vip/cfg/VIP_Gloves.txt");

	for(int i = 0; i < sizeof(sCmd); i++)
		AddCommandListener(CallBack_UseGloves, sCmd[i]);
}

public void OnAllPluginsLoaded()
{
	char sNameDB[64];
	FindConVar("sm_gloves_db_connection").GetString(sNameDB, sizeof(sNameDB));
	FindConVar("sm_gloves_table_prefix").GetString(g_sDBPrefix, sizeof(g_sDBPrefix));
	
	Database.Connect(Connect_CallBack, sNameDB);
}

public void Connect_CallBack(Handle hDatabase, const char[] sError, any data)
{
	if(sError[0])
	{
		ERROR("Ошибка подключения к базе данных!");
	}
	
	g_hDatabase = hDatabase;
}

public void VIP_OnClientLoaded(int client, bool bVIP)
{
	if(!bVIP || !VIP_GroupCheck(client))
	{
		char sQuery[256], sSteamClient[64];
		
		GetClientAuthId(client, AuthId_Steam2, sSteamClient, sizeof sSteamClient);
		FormatEx(sQuery, sizeof sQuery, "DELETE FROM `%sgloves` WHERE `steamid` == '%s'", g_sDBPrefix, sSteamClient);
		
		SQL_LockDatabase(g_hDatabase);
		SQL_FastQuery(g_hDatabase, sQuery);
		SQL_UnlockDatabase(g_hDatabase);
	}
}

public Action CallBack_UseGloves(int client, const char[] command, int argc)
{
	if(VIP_IsClientVIP(client))
	{
		if(!VIP_GroupCheck(client))
		{
			WarningPanel(client, g_sVIPMessage);
			return Plugin_Stop;
		}
	}
	else
	{
		WarningPanel(client, g_sWarning);
		return Plugin_Stop;
	}
	
	return Plugin_Continue;
}

void WarningPanel(int client, const char[] sMessage)
{
	VIP_PrintToChatClient(client, sMessage);

	Panel hPanel = new Panel();
	hPanel.DrawText(sMessage);
	hPanel.Send(client, Panel_CallBack, 1);
	
	CloseHandle(hPanel);
}

public int Panel_CallBack(Menu menu, MenuAction actions, int item, int client){}

bool VIP_GroupCheck(int client)
{
	if(!(g_sVIPGroup[0] == '@' && g_sVIPGroup[3] == 'l'))
	{
		char sGroup[64];
		VIP_GetClientVIPGroup(client, sGroup, sizeof(sGroup));
		
		if(StrContains(g_sVIPGroup, sGroup, false) == -1)
		{
			return false;
		}
	}
	
	return true;
}

void Load_KeyValues(const char[] sFile)
{
	char sPath[128];
	BuildPath(Path_SM, sPath, sizeof(sPath), sFile);
	
	g_hKeyValues = new KeyValues("VIP_Gloves");
	if(!g_hKeyValues.ImportFromFile(sPath))
	{
		ERROR("Не был найден файл: %s", sFile);
	}
	
	g_hKeyValues.GetString("message_global", g_sWarning, sizeof(g_sWarning), "Данная функция доступна только игрокам с VIP-статусом");
	g_hKeyValues.GetString("vipgroup", g_sVIPGroup, sizeof(g_sVIPGroup), "@all");
	g_hKeyValues.GetString("message_vip", g_sVIPMessage, sizeof(g_sVIPMessage));
}